Attribute VB_Name = "Folder_MOD"
Option Explicit

Private Const MAX_PATH = 260
Private Const BIF_RETURNONLYFSDIRS = &H1&
Private Const BIF_STATUSTEXT = &H4
Private Const WM_USER = &H400
Private Const BFFM_INITIALIZED = 1
Private Const BFFM_SELCHANGED = 2
Private Const BFFM_SETSTATUSTEXT = WM_USER + 100
Private Const BFFM_SETSELECTION = WM_USER + 102
Private Const SHGFI_DISPLAYNAME = &H200
Private Const SHGFI_PIDL = &H8
Private Const WM_SETTEXT = &HC

Private Declare Function BrowseForFolder Lib "shell32" Alias "SHBrowseForFolder" _
    (lpbi As udtBrowseInfo) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function GetPathFromIDList Lib "shell32" Alias "SHGetPathFromIDList" _
    (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function SHGetFileInfo Lib "shell32" Alias "SHGetFileInfoA" _
    (ByVal pszPath As Any, ByVal dwFileAttributes As Long, psfi As udtShowFileInfo, ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
    (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
    
Type udtBrowseInfo 'brs
    hwndOwner       As Long
    pidlRoot        As Long
    pszDisplayName  As String
    lpszTitle       As String
    ulFlags         As Long
    lpfn            As Long
    lParam          As String
    iImage          As Long
End Type

Type udtShowFileInfo 'sfi
    hIcon           As Long
    iIcon           As Long
    dwAttributes    As Long
    szDisplayName   As String * MAX_PATH
    szTypeName      As String * 80
End Type

Private Sub BrowseCallbackProc(ByVal plngHndWnd As Long, _
                               ByVal plngUMsg As Long, _
                               ByVal plngParam As Long, _
                               ByVal pstrLpData As String)
    
    Dim strPath As String * MAX_PATH
    Dim sfiMyPath As udtShowFileInfo
            
    If plngUMsg = BFFM_SELCHANGED Then
        
        GetPathFromIDList plngParam, strPath
        
        If Asc(strPath) = 0 Then
            SHGetFileInfo plngParam, 0, sfiMyPath, Len(sfiMyPath), SHGFI_DISPLAYNAME Or SHGFI_PIDL
            strPath = sfiMyPath.szDisplayName
        End If
        
        SendMessage plngHndWnd, BFFM_SETSTATUSTEXT, 0&, ByVal strPath
        
    ElseIf plngUMsg = BFFM_INITIALIZED Then
        
        SendMessage plngHndWnd, BFFM_SETSELECTION, True, ByVal pstrLpData
        SendMessage plngHndWnd, WM_SETTEXT, 0, ByVal "  ."
        
    End If
    
End Sub

Public Function FUN_Browse_Folder(ByVal pstrStartFolder As String) As String
 
    Dim brsMyBrwsInfo As udtBrowseInfo
    Dim lngRetFldrBrws As Long
    Dim strPath As String * MAX_PATH
    Dim strReturn As String
    
    CopyMemory brsMyBrwsInfo.lpfn, AddressOf BrowseCallbackProc, 4
    
    With brsMyBrwsInfo
        .ulFlags = BIF_RETURNONLYFSDIRS Or BIF_STATUSTEXT
        .hwndOwner = Screen.ActiveForm.hwnd
        .lParam = StrConv(Trim$(pstrStartFolder), vbUnicode)
        .lpszTitle = "  :"
    End With
    
    lngRetFldrBrws = BrowseForFolder(brsMyBrwsInfo)
    
    If lngRetFldrBrws Then
        GetPathFromIDList lngRetFldrBrws, strPath
        strReturn = Left$(strPath, InStr(strPath, vbNullChar) - 1)
    Else
        strReturn = pstrStartFolder
    End If
    
    FUN_Browse_Folder = IIf(strReturn = vbNullString, vbNullString, _
                   IIf(Right$(strReturn, 1) = "\", strReturn, strReturn & "\"))

End Function
Public Function FUN_FOLDER_OUT_PATCH(Long_patch) As String
'        
Dim F
    Set F = fso.GetFile(Long_patch)
' - , ,
'    
MsgBox F.ShortName
MsgBox F.Name

End Function

Public Function FUN_PATCH_OUT_PATCH(Long_patch) As String
'      
    Dim F
'    Set fso = CreateObject("Scripting.FileSystemObject")
If GLB_Proverka = True Then Call FUN_IN_TXT(FUN_Patch_File(App.Path, "Process_Log.txt"), Now() & " _ " & "FOLDER_MOD" & " _ " & "FUN_PATCH_OUT_PATCH")

'---------------------------------------------------------------------------
On Error GoTo FUN_PATCH_OUT_PATCH_Error
'---------------------------------------------------------------------------
    Set F = fso.GetFile(Long_patch)
  FUN_PATCH_OUT_PATCH = Left(Long_patch, InStr(1, Long_patch, F.Name, 3) - 1)
 If Right(FUN_PATCH_OUT_PATCH, 1) = "\" Then FUN_PATCH_OUT_PATCH = Left(FUN_PATCH_OUT_PATCH, Len(FUN_PATCH_OUT_PATCH) - 1)
 Set F = Nothing
'---------------------------------------------------------------------------
On Error GoTo 0
Exit Function
FUN_PATCH_OUT_PATCH_Error:
Error_String = Err.Description: Call FUN_IN_TXT(FUN_Patch_File(App.Path, "Error.txt"), Now() & " _ " & "FOLDER_MOD" & " _ " & "FUN_PATCH_OUT_PATCH" & " ..." & Error_String)

End Function

  
  
Public Function FUN_FOLDER_YES_NO(Path_Name As String) As Boolean
'   
'  Dim fso As FileSystemObject
'   Set fso = CreateObject("Scripting.FileSystemObject")
If GLB_Proverka = True Then Call FUN_IN_TXT(FUN_Patch_File(App.Path, "Process_Log.txt"), Now() & " _ " & "FOLDER_MOD" & " _ " & "FUN_FOLDER_YES_NO")

'---------------------------------------------------------------------------
On Error GoTo FUN_FOLDER_YES_NO_Error
'---------------------------------------------------------------------------
   If fso.FolderExists(Path_Name) Then
    FUN_FOLDER_YES_NO = True '"  "
   Else
    FUN_FOLDER_YES_NO = False '"  "
'    FUN_Create_Patch_Folder (Path_Name) ' 
   End If
'---------------------------------------------------------------------------
On Error GoTo 0
Exit Function
FUN_FOLDER_YES_NO_Error:
Error_String = Err.Description: Call FUN_IN_TXT(FUN_Patch_File(App.Path, "Error.txt"), Now() & " _ " & "FOLDER_MOD" & " _ " & "FUN_FOLDER_YES_NO" & " ..." & Error_String)

End Function
Function FUN_Create_Patch_Folder(Patch_Name As String)
'     

Dim fso As FileSystemObject
If GLB_Proverka = True Then Call FUN_IN_TXT(FUN_Patch_File(App.Path, "Process_Log.txt"), Now() & " _ " & "FOLDER_MOD" & " _ " & "FUN_Create_Patch_Folder")

'---------------------------------------------------------------------------
On Error GoTo FUN_Create_Patch_Folder_Error
'---------------------------------------------------------------------------
Set fso = New Scripting.FileSystemObject
If Right(Patch_Name, 1) = "\" Then Patch_Name = Left(Patch_Name, Len(Patch_Name) - 1)
fso.CreateFolder Patch_Name
'---------------------------------------------------------------------------
On Error GoTo 0
Exit Function
FUN_Create_Patch_Folder_Error:
Error_String = Err.Description: Call FUN_IN_TXT(FUN_Patch_File(App.Path, "Error.txt"), Now() & " _ " & "FOLDER_MOD" & " _ " & "FUN_Create_Patch_Folder" & " ..." & Error_String)

End Function

Function FUN_Patch_File(Patch_Name As String, File_Name As String) As String
'fso.BuildPath (Path, Name)
'    .
'    \   Path
'   Name      .
'     App.Path,    
'   


'---------------------------------------------------------------------------
On Error GoTo FUN_Patch_File_Error
'---------------------------------------------------------------------------
Set fso = New Scripting.FileSystemObject
FUN_Patch_File = fso.BuildPath(Patch_Name, File_Name)
'---------------------------------------------------------------------------
On Error GoTo 0
Exit Function
FUN_Patch_File_Error:
Error_String = Err.Description: Call FUN_IN_TXT(FUN_Patch_File(App.Path, "Error.txt"), Now() & " _ " & "FOLDER_MOD" & " _ " & "FUN_Patch_File" & " ..." & Error_String)


End Function


Function FUN_Copy_Patch(Patch_Name As String, Patch_Name1 As String)
'   
Dim fso As FileSystemObject
If GLB_Proverka = True Then Call FUN_IN_TXT(FUN_Patch_File(App.Path, "Process_Log.txt"), Now() & " _ " & "FOLDER_MOD" & " _ " & "FUN_Copy_Patch")

'---------------------------------------------------------------------------
On Error GoTo FUN_Copy_Patch_Error
'---------------------------------------------------------------------------
Set fso = New Scripting.FileSystemObject
fso.CopyFolder Patch_Name & "\*", Patch_Name1
'---------------------------------------------------------------------------
On Error GoTo 0
Exit Function
FUN_Copy_Patch_Error:
Error_String = Err.Description: Call FUN_IN_TXT(FUN_Patch_File(App.Path, "Error.txt"), Now() & " _ " & "FOLDER_MOD" & " _ " & "FUN_Copy_Patch" & " ..." & Error_String)


End Function



