Attribute VB_Name = "Sys_mod"
Private Type SYSTEM_INFO
dwOemID As Long
dwPageSize As Long
lpMinimumApplicationAddress As Long
lpMaximumApplicationAddress As Long
dwActiveProcessorMask As Long
dwNumberOrfProcessors As Long
dwProcessorType As Long
dwAllocationGranularity As Long
dwReserved As Long
End Type
Private Type OSVERSIONINFO
dwOSVersionInfoSize As Long
dwMajorVersion As Long
dwMinorVersion As Long
dwBuildNumber As Long
dwPlatformId As Long
szCSDVersion As String * 128
End Type
Private Type MEMORYSTATUS
dwLength As Long
dwMemoryLoad As Long
dwTotalPhys As Long
dwAvailPhys As Long
dwTotalPageFile As Long
dwAvailPageFile As Long
dwTotalVirtual As Long
dwAvailVirtual As Long
End Type
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (LpVersionInformation As OSVERSIONINFO) As Long
Private Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)
Private Declare Sub GetSystemInfo Lib "kernel32" (lpSystemInfo As SYSTEM_INFO)
Const PROCESSOR_INTEL_386 = 386
Const PROCESSOR_INTEL_486 = 486
Const PROCESSOR_INTEL_PENTIUM = 586
Const PROCESSOR_MIPS_R4000 = 4000
Const PROCESSOR_ALPHA_21064 = 21064


Sub SystemInformation()
Dim msg As String ' Status information.
Dim NewLine As String ' New-line.
Dim ret As Integer ' OS Information
Dim ver_major As Integer ' OS Version
Dim ver_minor As Integer ' Minor Os Version
Dim Build As Long ' OS Build
Dim CPU As String
NewLine = Chr(13) + Chr(10) ' New-line.
' Get operating system and version.
Dim verinfo As OSVERSIONINFO
verinfo.dwOSVersionInfoSize = Len(verinfo)
ret = GetVersionEx(verinfo)
If ret = 0 Then
MsgBox "Error Getting Version Information"
End
End If
'MsgBox verinfo.dwPlatformId
Select Case verinfo.dwPlatformId
Case 0
msg = msg + "Windows 32s "
Case 1
msg = msg + "Windows 95 "
Case 2
msg = msg + "Windows NT "
End Select

ver_major = verinfo.dwMajorVersion
ver_minor = verinfo.dwMinorVersion
Build = verinfo.dwBuildNumber
msg = msg & ver_major & "." & ver_minor
msg = msg & " (Build " & Build & ")"
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "   " & String(30 - Len("  : "), "_") & msg)


' Get CPU type and operating mode.
Dim sysinfo As SYSTEM_INFO
GetSystemInfo sysinfo
msg = msg + "CPU: "

'MsgBox sysinfo.dwProcessorType
Select Case sysinfo.dwProcessorType
Case PROCESSOR_INTEL_386
msg = msg + "Intel 386" + NewLine
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "  : Intel 386")

Case PROCESSOR_INTEL_486
msg = msg + "Intel 486" + NewLine
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "  : Intel 486")

Case PROCESSOR_INTEL_PENTIUM
msg = msg + "Intel Pentium" + NewLine
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "  : Intel  Pentium")

Case PROCESSOR_MIPS_R4000
msg = msg + "MIPS R4000" + NewLine
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "  : MIPS R4000")

Case PROCESSOR_ALPHA_21064
msg = msg + "DEC Alpha 21064" + NewLine
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "  : DEC Alpha 21064")

Case Else
msg = msg + "(unknown)" + NewLine
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "  : ")

End Select
msg = msg + NewLine

' Get free memory.
Dim memsts As MEMORYSTATUS
Dim memory As Long
GlobalMemoryStatus memsts
memory = memsts.dwTotalPhys
msg = msg + "  : "
msg = msg + Format(memory \ 1024, "###,###,###") + "K" + NewLine
memory = memsts.dwAvailPhys
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "   : " & String(30 - Len("    "), "_") & Format(memory \ 1024, "###,###,###") + "K")

msg = msg + "  : "
msg = msg + Format(memory \ 1024, "###,###,###") + "K" + NewLine
memory = memsts.dwTotalVirtual
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "   : " & String(30 - Len("    "), "_") & Format(memory \ 1024, "###,###,###") + "K")

msg = msg + "  : "
msg = msg + Format(memory \ 1024, "###,###,###") + "K" + NewLine
memory = memsts.dwAvailVirtual
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "   :  " & String(30 - Len("    "), "_") & Format(memory \ 1024, "###,###,###") + "K")

msg = msg + "   : "
msg = msg + Format(memory \ 1024, "###,###,###") + "K" + NewLine
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "    : " & String(30 - Len(" Total Physical Memory "), "_") & Format(memory \ 1024, "###,###,###") + "K")

'MsgBox msg, vbOKOnly, "System Info"
'Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "  " & msg)

End Sub

Public Function Razdeliteli()
'      ,
'     Windows,  
' Locale Settings   API.
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "   " & Mid$(Format(Date, "General Date"), 3, 1))
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "   " & Mid$(Format(0.5, "Long Time"), 3, 1))
Call FUN_IN_TXT(Str_Patch_File & "Informations.txt", "   " & Mid$(Format(1.1, "General Number"), 2, 1))


'DateDelimiter = Mid$(Format(Date, _
'        "General Date"), 3, 1)
'TimeDelimiter = Mid$(Format(0.5, _
'        "Long Time"), 3, 1)
'DecimalDelimiter = Mid$(Format(1.1, _
'        "General Number"), 2, 1)
End Function



